using CloudBuilder.Core.DatabaseAccessor;
using CloudBuilder.Core.Policy;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using System.Transactions;
using CloudBuilder.Core.Service;
using CloudBuilder.Security.Service;
            using CloudBuilder.Core.DatabaseAccessor.Entity;
            using Microsoft.AspNetCore.Http;
            using CloudBuilder.Core.Policy;
            using CloudBuilder.Core.DependencyInjection.Request;
            using CloudBuilder.Security.Data;
            using CloudBuilder.Core.Authorization;
            using CloudBuilder.Security.Entity;
            using CloudBuilder.Security.SearchCriteria;
            using CloudBuilder.Security;
            using System;
            
namespace CloudBuilder.Web.Entry.Controllers.Security
{
[Authorize(AuthorizePolicy.PERMISSION)]
[ApiController]
[Route("[controller]/[action]")]
public class SecurityUserPreferenceController : ControllerBase
{
private readonly IApplicationService service;
private readonly ISecurityUserPreferenceService securityUserPreferenceService;

public SecurityUserPreferenceController(IApplicationService service, ISecurityUserPreferenceService securityUserPreferenceService)
{
this.service = service;
this.securityUserPreferenceService= securityUserPreferenceService;
}

        [AllowAnonymous]
                            [HttpPost]
                            public dynamic FindByKey(SecurityUserPreferenceEntityKey key)       
                    {
                    try
                    {            

                    var result = securityUserPreferenceService.FindByKey(key);
                    return result;
                    }
                    catch (ValidatedException vex)
                    {
                    return vex;
                    }            
                    catch (Exception ex)
                    {
                    return new ServiceErrorException(ex);
                    }           
                    }

                            [PermissionOperate(name: "SecurityUserPreference", operate: "Find")]
                            [HttpPost]
                            public dynamic FindBySearchCriteria(SecurityUserPreferenceSearchCriteria criteria)       
                    {
                    try
                    {            

                    var result = securityUserPreferenceService.FindBySearchCriteria(criteria);
                    return result;
                    }
                    catch (ValidatedException vex)
                    {
                    return vex;
                    }            
                    catch (Exception ex)
                    {
                    return new ServiceErrorException(ex);
                    }           
                    }

                            [PermissionOperate(name: "SecurityUserPreference", operate: "Print")]
                            [HttpPost]
                            public dynamic PrintBySearchCriteria(SecurityUserPreferenceSearchCriteria criteria)       
                    {
                    try
                    {            

                    var result = securityUserPreferenceService.PrintBySearchCriteria(criteria);
                    return result;
                    }
                    catch (ValidatedException vex)
                    {
                    return vex;
                    }            
                    catch (Exception ex)
                    {
                    return new ServiceErrorException(ex);
                    }           
                    }

                            [AllowAnonymous]
                            [HttpPost]
                            [UnitOfWork]
                            public dynamic Insert(SecurityUserPreferenceEntity data)       
                    {
                    try
                    {            

                    var result = securityUserPreferenceService.Insert(data);
                    return result;
                    }
                    catch (ValidatedException vex)
                    {
                    return vex;
                    }            
                    catch (Exception ex)
                    {
                    return new ServiceErrorException(ex);
                    }           
                    }

                            [AllowAnonymous]
                            [HttpPost]
                            [UnitOfWork]
                            public dynamic Update(SecurityUserPreferenceEntity data)       
                    {
                    try
                    {            

                    var result = securityUserPreferenceService.Update(data);
                    return result;
                    }
                    catch (ValidatedException vex)
                    {
                    return vex;
                    }            
                    catch (Exception ex)
                    {
                    return new ServiceErrorException(ex);
                    }           
                    }

                            [AllowAnonymous]
                            [HttpPost]
                            public dynamic Delete(SecurityUserPreferenceEntityKey key){
                    try
                    {            
                securityUserPreferenceService.Delete(key);

                    return string.Empty;
                    }
                    catch (ValidatedException vex)
                    {
                    return vex;
                    }            
                    catch (Exception ex)
                    {
                    return new ServiceErrorException(ex);
                    }                    
                    }

                    
}
}